<template>
  <div :class="$style.homepageWrapper">
    <base-container>
      <base-card :class="$style.card">
        <template #header>
          <base-spacing y="1">
            <base-typography elemType="h1" fontSize="1.2" type="bold">
              simple typescript Vuejs shop.
            </base-typography>
          </base-spacing>
        </template>
        <template #main-content>
          <base-spacing y="2">
            <base-typography elemType="p" fontSize="0.9rem" type="light">
              This is just a simple project and some of things that I have
              developed and used here is not neccessary good for such small
              project.
            </base-typography>
            <base-spacing y="1">
              <base-typography elemType="p" fontSize="0.8rem" type="bold">
                you need to login to access other pages. otherwise you will be
                redirected to this page.
              </base-typography>
            </base-spacing>

            <base-typography
              elemType="p"
              fontSize="0.8rem"
              type="bold"
              :color="isAuthenticated ? 'primary' : 'danger'"
            >
              {{ isAuthenticatedText }}.
              <router-link v-if="isAuthenticated" to="/product/1">
                let's go and see product page</router-link
              >
            </base-typography>
          </base-spacing>
        </template>
        <template #footer>
          <base-spacing y="1">
            <div :class="$style.actionWrapper">
              <base-button
                :disabled="isAuthenticated"
                :style="{ width: '100%', marginRight: '0.5rem' }"
                @click="handleClick('login')"
                >Login</base-button
              >
              <base-button
                theme="outline-primary"
                :disabled="!isAuthenticated"
                @click="handleClick('logOut')"
              >
                Logout</base-button
              >
            </div>
          </base-spacing>
        </template>
      </base-card>
    </base-container>
  </div>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/ban-ts-ignore */

import BaseButton from "@/components/base/BaseButton/index.vue";
import BaseCard from "@/components/base/BaseCard/index.vue";
import BaseContainer from "@/components/base/BaseGrid/container.vue";
import BaseTypography from "@/components/base/BaseTypography/index.vue";
import BaseSpacing from "@/components/base/BaseSpacing/index.vue";
import AuthenticationMixin from "@/mixins/Auth/index";
// vuex

export enum AUTH_CONTENT {
  LOGIN = "Hey! you Are Authenticated",
  LOGOUT = "You Are not Authenticated!",
}

export default {
  name: "Home",
  mixins: [AuthenticationMixin],
  components: {
    BaseButton,
    BaseCard,
    BaseContainer,
    BaseTypography,
    BaseSpacing,
  },
  methods: {
    handleClick: function(action: string): void {
      if (action === "login") {
        // @ts-ignore
        return this.loginUserFromAuthMixin();
      }
      // @ts-ignore
      this.logOutUserFromAuthMixin();
    },
  },
  computed: {
    isAuthenticated: function() {
      // @ts-ignore
      if (!this.isAuthenticationPending && this.isAuthenticatedFromAuthMixin) {
        return true;
      }
      return false;
    },
    isAuthenticatedText: function() {
      // @ts-ignore
      if (!this.isAuthenticationPending && this.isAuthenticatedFromAuthMixin) {
        return AUTH_CONTENT.LOGIN;
      }
      return AUTH_CONTENT.LOGOUT;
    },
  },
};
</script>

<style module lang="scss">
.actionWrapper {
  composes: display--flex;
}
.card {
  max-width: 400px;
  margin: 0 auto;
  padding: 1rem 2rem;
}
.homepageWrapper {
  min-height: 90vh;
  composes: display--flex;
  composes: align-items--center;
  composes: justify-content--center;
}
</style>
